Skip to main content

GetDeveloperUsage - Get member usage data list

Retrieve data about developers who have used Qoder CN via OpenAPI.
Applies to: Enterprise Dedicated Edition, Enterprise Standard Edition
Service access point: Get the service access point and replace {domain} in the API request syntax.

Authorization

ProductResourceRequired permission
Qoder CNDeveloper usage statisticsRead-only

Request Syntax

GET https://{domain}/oapi/v1/lingma/organizations/{organizationId}/developerUsage

Request description

  • Enterprise Standard Edition
  • Enterprise Dedicated Edition
  • Query usage data for all users
  • Query usage data for a specific user
curl -X 'GET' \
  'https://openapi-rdc.aliyuncs.com/oapi/v1/lingma/organizations/67d8e0b9120358055abf****/developerUsage?startTime=2024-02-01&endTime=2025-05-31' \
  -H 'Content-Type: application/json' \
  -H 'x-yunxiao-token: pt-0fh3****0fbG_35af****0484'

Request Headers

x-yunxiao-token string (Required) Personal access token. See Personal access token for how to obtain it. Example: pt-0fh30fbG_35af0484.

Request Parameters

string
path
required
Organization ID.
string
path
required
The start time, in YYYY-MM-DD format.
string
path
required
The end time, in YYYY-MM-DD format.
string
path
User ID.You can specify either the user ID or the department ID. If you specify both parameters, the system uses the user ID for filtering. If you do not specify either parameter, the system queries data for all users in the organization.
string
path
Department ID.You can specify either the user ID or the department ID. If you specify both parameters, the system uses the user ID for filtering. If you do not specify either parameter, the system queries data for all users in the organization.
integer
path
default:"1"
The current page number.
integer
path
default:"100"
The number of data entries per page.

Response Fields

  • Response for all user usage data
  • Response for specific user usage data
[
    {
        "breakdown": {
            "chatting": [
                {
                    "chatTurns": 1,
                    "chatTurnsAccepted": 1,
                    "chatType": "GENERATE_TESTCASE",
                    "ide": "jetbrains"
                }
            ],
            "coding": [
                {
                    "acceptAssistantNewlineCount": 0,
                    "language": "java",
                    "linesAccepted": 79,
                    "linesChanged": 79
                }
            ],
            "completion": [
                {
                    "countAccepted": 1,
                    "countSuggested": 1,
                    "ide": "jetbrains",
                    "language": "java",
                    "linesAccepted": 1,
                    "linesSuggested": 1
                }
            ]
        },
        "date": 1749484800000,
        "statusActive": true,
        "statusActiveChat": true,
        "statusActiveCompletion": true,
        "statusActiveLastedTime": 1749570900000,
        "totalChatTurns": 1,
        "totalChatTurnsAccepted": 1,
        "totalCountAcceptedCompletion": 1,
        "totalCountSuggestedCompletion": 1,
        "totalLinesAccepted": 79,
        "totalLinesAcceptedChat": 0,
        "totalLinesAcceptedCompletion": 1,
        "totalLinesChanged": 79,
        "totalLinesSuggestedCompletion": 1,
        "userId": "10107ac8-59af-4391-8df5-ea4472bb****"
    }
]
Object
Detailed data.
array
Q&A interaction details.
integer
The number of chat turns.
integer
The number of accepted answers.
string
The type of chat:
  • CODE_GENERATE_COMMENT: Code comments.
  • GENERATE_TESTCASE: Unit tests.
  • EXPLAIN_CODE: Code explanation.
  • OPTIMIZE_CODE: Code optimization.
  • FREE_INPUT: Free-form Q&A. This is a non-uppercase string for a custom instruction.
string
The IDE type, such as JetBrains or VS Code.
array
Code change details, including summary of accepted code from inline completions and Q&A generations.
string
Language.
integer
The number of accepted lines of code.
integer
The number of changed lines of code.
integer
Lines of code accepted by the user on that day, broken down by Q&A type and language.
array
Inline completion generation and acceptance details.
integer
The number of acceptances.
integer
The number of suggestions.
string
The IDE type, such as jetbrains or vscode.
string
Language.
integer
The number of accepted lines of code.
integer
The number of changed lines of code.
integer
The number of suggested lines of code.
integer
The date.
boolean
Indicates whether the user is active.
  • true: The user is active.
  • false: The user is inactive.
boolean
Indicates whether the user is active in chat.
  • true: The user is active in chat.
  • false: The user is inactive in chat.
boolean
Indicates whether the user is active in code generation.
  • true: The user is active in code generation.
  • false: The user is inactive in code generation.
string
The last time the user was active on that day.
integer
Total chat turns for the user on that day.
integer
Total lines of code accepted by the user via Q&A on that day.
integer
Total lines of code accepted by the user on that day, including lines from ask, edit (formerly AI Programmer), agent Q&A generation, and inline completions.
integer
Total lines of code changed by the user on that day, including lines from ask, edit (formerly AI Programmer), agent Q&A generation, and inline completions.
integer
Total lines of code suggested by inline completions on that day.
integer
Total lines from inline completions accepted by the user on that day.
integer
Total inline completion suggestions for the user on that day.
integer
Total inline completion suggestions accepted by the user on that day.
integer
Total chat turns accepted by the user on that day.
string
User ID.

Response Headers

ParameterDescriptionExample value
x-next-pageThe next page2
x-pageThe current page1
x-per-pageThe number of entries per page100
x-prev-pageThe previous page0
x-request-idThe request ID37294673-00CA-5B8B-914F-A8B35511E90A
x-totalThe total number of entries10
x-total-pagesThe total number of pages1

Error Codes

For related API error codes, see the API error codes reference.